#include <cstdlib>
#include <cstdio>
#include <iostream>

using namespace std;

int ptr = 0;

struct comb
{
  long long num;
  long long iter;
};

int compare(const void * a, const void * b)
{
  return( (long long)(*(struct comb *)a).num - (long long)(*(struct comb *)b).num); 
}

int compareMyType(const void * a, const void * b)
{
  if( (long long)(*(struct comb*)a).num > (long long)(*(struct comb*)b).num) return 1;
  if( (long long)(*(struct comb*)a).num == (long long)(*(struct comb*)b).num) return 0;
  if( (long long)(*(struct comb*)a).num < (long long)(*(struct comb*)b).num) return -1;
  return 0; //never reached
}


void next(struct comb& in)
{
  if((in.num % 2) == 0)
    {
      in.num = in.num >> 1;
    }
  else
    {
      in.num = 3 * in.num + 1;
    }
  in.iter++;
 }

int main()
{
  long long x1; long long x2;
  long long vysl1; 
  //long long vysl2;
  long long orig1; long long orig2;
  
  struct comb mnozina[1024000];
  long long swap = 0;
  struct comb * cptr;
  long long comp1; long long comp2;


  
  while(1)
    {
      ptr = 0;
      struct comb test;
      test.iter = 0;
      scanf("%lld %lld", &x1, &x2);
      orig1 = x1;
      orig2 = x2;

      if(x1 == x2)
	{
	  test.num = x1;
	  next(test);
	  printf("%ld needs %d steps, %ld needs %d steps, they meet at %lld\n",
		 x1, 1, x2, 1, test.num);
	  exit(0);
	}


      if((x1 == 0) && (x2 == 0))
	{
	  break;
	}
      if((x1 % 2) == 0)
	{
	  comp1 = x1 / 2;
	}
      else
	{
	  comp1 = x1 * 3 + 1;
	}
      if((x2 % 2) == 0)
	{
	  comp2 = x2 / 2;
	}
      else
	{
	  comp2 = x2 * 3 + 1;
	}

      if(comp1 < comp2)
	{
	  test.num = x1;
	}
      else 
	{
	  test.num = x2;
	  swap = 1;
	}

      while(test.num != 1)
	{
	  mnozina[ptr] = test;
	  ptr++;
	  next(test);
	}
      if(swap == 1)
	{
	  test.num = x1;
	}
      else
	{
	  test.num = x2;
	}
      test.iter = 0;

      qsort(mnozina, ptr, sizeof(struct comb), compare);

      while(1)
	{
	  cptr = (struct comb *) bsearch((void *)&test.num, (void *)mnozina, ptr, sizeof(struct comb), compareMyType);
	  if(cptr != NULL)
	    {
	      vysl1 = (long long)(*(struct comb *)cptr).iter;
	      goto end;
	    }
	  next(test);
	}
    end:
      if(swap == 1)
	{
	  printf("%lld needs %d steps, %lld needs %d steps, they meet at %lld\n",
		 x1, test.iter, x2, vysl1, test.num);
	}
      else
	{
	  printf("%lld needs %d steps, %lld needs %d steps, they meet at %lld\n",
		 x1, vysl1, x2, test.iter, test.num);
	}
    }


  return 0;
}

